package eu.dnetlib.ariadneplus.elasticsearch.model;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import java.util.Map;


public class Spatial {
    private String address;
    private String boundingBoxMaxLat;
    private String boundingBoxMaxLon;
    private String boundingBoxMinLat;
    private String boundingBoxMinLon;
    private String coordinateSystem;
    private String country;
    private AriadneGeoPoint location;
    private String placeName;

    public static Spatial fromRDFJson(JsonElement json, Map<String,JsonElement> map) {
        Spatial pi = new Spatial();
        for (Map.Entry<String, JsonElement> entry : json.getAsJsonObject().entrySet()){
            switch (entry.getKey()){
                case "http://www.myprefix/address" :
                    pi.setAddress(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/boundingBoxMaxLat":
                    pi.setBoundingBoxMaxLat(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/boundingBoxMaxLon":
                    pi.setBoundingBoxMaxLon(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/boundingBoxMinLat":
                    pi.setBoundingBoxMinLat(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/boundingBoxMinLon":
                    pi.setBoundingBoxMinLon(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/country":
                    pi.setCountry(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
                case "http://www.myprefix/coordinateSystem":
                   pi.setCoordinateSystem(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                   break;
                case "http://www.myprefix/location":
                    String map_key = entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString();
                    pi.setLocation(AriadneGeoPoint.fromRDFJson(map.get(map_key)));
                    break;
                case "http://www.myprefix/placeName":
                    pi.setPlaceName(entry.getValue().getAsJsonArray().get(0).getAsJsonObject().get("value").getAsString());
                    break;
            }
        }

        return pi;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getBoundingBoxMaxLat() {
        return boundingBoxMaxLat;
    }

    public void setBoundingBoxMaxLat(String boundingBoxMaxLat) {
        this.boundingBoxMaxLat = boundingBoxMaxLat;
    }

    public String getBoundingBoxMaxLon() {
        return boundingBoxMaxLon;
    }

    public void setBoundingBoxMaxLon(String boundingBoxMaxLon) {
        this.boundingBoxMaxLon = boundingBoxMaxLon;
    }

    public String getBoundingBoxMinLat() {
        return boundingBoxMinLat;
    }

    public void setBoundingBoxMinLat(String boundingBoxMinLat) {
        this.boundingBoxMinLat = boundingBoxMinLat;
    }

    public String getBoundingBoxMinLon() {
        return boundingBoxMinLon;
    }

    public void setBoundingBoxMinLon(String boundingBoxMinLon) {
        this.boundingBoxMinLon = boundingBoxMinLon;
    }

    public String getCoordinateSystem() {
        return coordinateSystem;
    }

    public void setCoordinateSystem(String coordinateSystem) {
        this.coordinateSystem = coordinateSystem;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public AriadneGeoPoint getLocation() {
        return location;
    }

    public void setLocation(AriadneGeoPoint location) {
        this.location = location;
    }

    public String getPlaceName() {
        return placeName;
    }

    public void setPlaceName(String placeName) {
        this.placeName = placeName;
    }

    public Spatial() {
    }

    public static Spatial fromJson(String json){
        return new Gson().fromJson(json, Spatial.class);
    }
}
